//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Base 64 encoder / decoder
#include <vcl.h>
#include <string.h>

#pragma hdrstop

#include "Base64.h"

//-------------------------
AnsiString Base64Encode(char *input)
{
   char keyStr[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

   AnsiString output = "";
   char chr1, chr2, chr3;
   char enc1, enc2, enc3, enc4;
   int i = 0, l;

   l = strlen(input);

   do {
      chr1 = input[i++];
      enc1 = chr1 >> 2;

      if ( i<l ) {
        chr2 = input[i++];
        enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);

        if ( i<l ) {
          chr3 = input[i++];
          enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
          enc4 = chr3 & 63;
        } else {
          enc3 = ((chr2 & 15) << 2);
          enc4 = 64;
        }

      } else {
         enc2 = ((chr1 & 3) << 4);
         enc3 = 64;
         enc4 = 64;
      }

      output += AnsiString(keyStr[enc1]) + AnsiString(keyStr[enc2]) + AnsiString(keyStr[enc3]) + AnsiString(keyStr[enc4]);
   } while (i < l);
   
   return output;
}
//---------------------------------------------------------------------------
AnsiString Base64Decode(char *input)
{
   char keyStr[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

   AnsiString output = "";
   char chr1, chr2, chr3;
   char enc1, enc2, enc3, enc4;
   int i = 0, l;

   // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
//   input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

   l = strlen(input);

   do {
      enc1 = strchr( keyStr, input[i++] ) - keyStr;
      if (i<l) enc2 = strchr( keyStr, input[i++] ) - keyStr; else enc2 = 0;
      if (i<l) enc3 = strchr( keyStr, input[i++] ) - keyStr; else enc3 = 0;
      if (i<l) enc4 = strchr( keyStr, input[i++] ) - keyStr; else enc4 = 0;

      chr1 = (enc1 << 2) | (enc2 >> 4);
      chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
      chr3 = ((enc3 & 3) << 6) | enc4;

      output += AnsiString(chr1);

      if (enc3 != 64) {
         output += AnsiString(chr2);
      }
      if (enc4 != 64) {
         output += AnsiString(chr3);
      }
   } while (i < l);

   return output;

}
//---------------------------------------------------------------------------



#pragma package(smart_init)
